Bug 27403 - Enable fixedHeader for Datatables
Summary: Enable fixedHeader for Datatables
Status: Pushed to master
Alias: None
Product: Koha
Classification: Unclassified
Component: Templates (show other bugs)
Version: unspecified
Hardware: All All
: P5 - low enhancement (vote)
Assignee: Jonathan Druart
QA Contact: Testopia
URL:
Keywords: release-notes-needed
: 27417 (view as bug list)
Depends on:
Blocks: 27467 27682 27605
  Show dependency treegraph
 
Reported: 2021-01-12 09:25 UTC by Jonathan Druart
Modified: 2021-05-27 10:08 UTC (History)
4 users (show)

See Also:
Change sponsored?: ---
Patch complexity: Trivial patch
Text to go in the release notes:
Version(s) released in:
21.05.00


Attachments
Bug 27403: Add fixedHeader to Datatables (10.23 KB, patch)
2021-01-12 09:27 UTC, Jonathan Druart
Details | Diff | Splinter Review
Bug 27403: Add fixedHeader to Datatables (10.29 KB, patch)
2021-01-12 19:03 UTC, Lucas Gass
Details | Diff | Splinter Review
Bug 27403: Add fixedHeader to Datatables (1.04 KB, patch)
2021-01-19 12:14 UTC, Jonathan Druart
Details | Diff | Splinter Review
Bug 27403: Add fixedHeader to Datatables (1.09 KB, patch)
2021-01-19 14:08 UTC, Owen Leonard
Details | Diff | Splinter Review
Bug 27403: (follow-up) Make basket toolbar and table header work together (1.93 KB, patch)
2021-01-19 14:08 UTC, Owen Leonard
Details | Diff | Splinter Review
Bug 27403: Disable fixedHeader on itemsearch (1.11 KB, patch)
2021-01-19 15:21 UTC, Jonathan Druart
Details | Diff | Splinter Review
Bug 27403: (follow-up) Make basket toolbar and table header work together (1.99 KB, patch)
2021-01-29 00:32 UTC, Lucas Gass
Details | Diff | Splinter Review
Bug 27403: Possible item search fix (1.44 KB, patch)
2021-01-29 00:41 UTC, Lucas Gass
Details | Diff | Splinter Review
Bug 27403: Add fixedHeader to Datatables (1.15 KB, patch)
2021-02-08 21:01 UTC, Katrin Fischer
Details | Diff | Splinter Review
Bug 27403: Disable fixedHeader on itemsearch (1.17 KB, patch)
2021-02-08 21:01 UTC, Katrin Fischer
Details | Diff | Splinter Review
Bug 27403: (follow-up) Make basket toolbar and table header work together (2.04 KB, patch)
2021-02-08 21:01 UTC, Katrin Fischer
Details | Diff | Splinter Review

Note You need to log in before you can comment on or make changes to this bug.
Description Jonathan Druart 2021-01-12 09:25:26 UTC
This is a nice Datatables plugin that we should enable on our tables.
Comment 1 Jonathan Druart 2021-01-12 09:27:12 UTC
Created attachment 115055 [details] [review]
Bug 27403: Add fixedHeader to Datatables

That's a great plugin to have fixed header.

Test plan:
On the cities table or the patron search table confirm that the header
is floating is you scroll down
Comment 2 Lucas Gass 2021-01-12 19:03:02 UTC
Works well in both Chrome and Firefox, this will save a lot of confusion when looking at larger tables.
Comment 3 Lucas Gass 2021-01-12 19:03:29 UTC
Created attachment 115098 [details] [review]
Bug 27403: Add fixedHeader to Datatables

That's a great plugin to have fixed header.

Test plan:
On the cities table or the patron search table confirm that the header
is floating is you scroll down

Signed-off-by: Lucas Gass <lucas@bywatersolutions.com>
Comment 4 Lucas Gass 2021-01-12 19:07:07 UTC
*** Bug 27417 has been marked as a duplicate of this bug. ***
Comment 5 Katrin Fischer 2021-01-17 16:21:54 UTC
This appears to work quite well, but can you please add a note about the new plugin to the About page?

Small thing: for a table like our current circulation conditions it's possible that the header line will hide the row with the input fields when scrolling down. Not sure this should be a blocker really - the feature is nice and people just need to scroll up a bit again.
Comment 6 Jonathan Druart 2021-01-19 12:14:09 UTC
Created attachment 115314 [details] [review]
Bug 27403: Add fixedHeader to Datatables

That's a great plugin to have fixed header.

Test plan:
On the cities table or the patron search table confirm that the header
is floating is you scroll down
Comment 7 Jonathan Druart 2021-01-19 12:14:50 UTC
Sooo, actually we don't need to add the dataTables.fixedHeader.min.js file, the feature exists in the datatables.min.js file we embed.
Comment 8 Owen Leonard 2021-01-19 14:08:04 UTC
Created attachment 115323 [details] [review]
Bug 27403: Add fixedHeader to Datatables

That's a great plugin to have fixed header.

Test plan:
On the cities table or the patron search table confirm that the header
is floating is you scroll down

Signed-off-by: Owen Leonard <oleonard@myacpl.org>
Comment 9 Owen Leonard 2021-01-19 14:08:06 UTC
Created attachment 115324 [details] [review]
Bug 27403: (follow-up) Make basket toolbar and table header work together

The fixed header option for DataTables does the same thing that the
hcSticky jQuery plugin does for us on toolbars, so I've gone through the
templates looking for places they might conflict.

On the acquisitions basket page we can add a special class,
"fh-fixedHeader," to the sticky toolbar to tell DataTables that the
table header should float *below* the toolbar.

To test, apply the patch and go to Acquisitions.

- Locate a vendor and a basket for that vendor with multiple orders.
- Adjust the browse window height if necessary to trigger vertical
  scrolling.
- Confirm that as you scroll down the toolbar (with buttons "Add to
  basket," "Edit basket," etc) sticks to the top of the browser window.
- Confirm that as you continue to scroll, the table header sticks below
  the floating toolbar.
Comment 10 Owen Leonard 2021-01-19 14:14:14 UTC
(In reply to Owen Leonard from comment #9)
> I've gone through the
> templates looking for places they might conflict.

The only other instance I found was on the item search page, where there is some strange behavior. To reproduce:

1. Submit an item search that will return multiple results.
2. After the results have loaded, click the "Edit search" button.
3. As you scroll down, the toolbar sticks to the top of the browser window but then the table header jumps into view before the table of results has scrolled into view.
Comment 11 Jonathan Druart 2021-01-19 15:21:34 UTC
Created attachment 115333 [details] [review]
Bug 27403: Disable fixedHeader on itemsearch

It does not work.
Comment 12 Jonathan Druart 2021-01-19 15:22:15 UTC
Thanks for the follow-up, Owen!

I have no idea about what's happening on the item search view so I am suggesting to simply disable fixedHeader on this page.
Comment 13 Lucas Gass 2021-01-29 00:32:28 UTC
Created attachment 116004 [details] [review]
Bug 27403: (follow-up) Make basket toolbar and table header work together

The fixed header option for DataTables does the same thing that the
hcSticky jQuery plugin does for us on toolbars, so I've gone through the
templates looking for places they might conflict.

On the acquisitions basket page we can add a special class,
"fh-fixedHeader," to the sticky toolbar to tell DataTables that the
table header should float *below* the toolbar.

To test, apply the patch and go to Acquisitions.

- Locate a vendor and a basket for that vendor with multiple orders.
- Adjust the browse window height if necessary to trigger vertical
  scrolling.
- Confirm that as you scroll down the toolbar (with buttons "Add to
  basket," "Edit basket," etc) sticks to the top of the browser window.
- Confirm that as you continue to scroll, the table header sticks below
  the floating toolbar.

Signed-off-by: Lucas Gass <lucas@bywatersolutions.com>
Comment 14 Lucas Gass 2021-01-29 00:34:53 UTC
(In reply to Jonathan Druart from comment #12)
> Thanks for the follow-up, Owen!
> 
> I have no idea about what's happening on the item search view so I am
> suggesting to simply disable fixedHeader on this page.

I think why this acts weird is because when you 'Edit search' we show the #item-search-block but the DataTable still thinks it is in the original location even though it has moved down on the page.
You can use destory(), I think to make this work
Comment 15 Lucas Gass 2021-01-29 00:41:09 UTC
Created attachment 116005 [details] [review]
Bug 27403: Possible item search fix

1. Submit an item search that will return multiple results.
2. After the results have loaded, click the "Edit search" button.
3. As you scroll down, the toolbar sticks to the top of the browser window but then the table header jumps into view before the table of results has scrolled into view.
4. Apply this patch and try again, the table header should not act weird.
5. Make sure all the dataTable controls still work
Comment 16 Owen Leonard 2021-02-08 16:29:48 UTC
(In reply to Lucas Gass from comment #15)
> Created attachment 116005 [details] [review] [review]
> Bug 27403: Possible item search fix

This works at first but after clicking the "Edit search" button the DataTable doesn't work correctly. The configuration looks broken and not all results are accessible.

I'm changing this to "Signed off" because I think the the follow-up which disables the feature on the item search page is acceptable.
Comment 17 Lucas Gass 2021-02-08 16:31:37 UTC
(In reply to Owen Leonard from comment #16)
> (In reply to Lucas Gass from comment #15)
> > Created attachment 116005 [details] [review] [review] [review]
> > Bug 27403: Possible item search fix
> 
> This works at first but after clicking the "Edit search" button the
> DataTable doesn't work correctly. The configuration looks broken and not all
> results are accessible.
> 
> I'm changing this to "Signed off" because I think the the follow-up which
> disables the feature on the item search page is acceptable.

Sounds good! I'm obsoleting my patch in that case.
Comment 18 Katrin Fischer 2021-02-08 20:57:47 UTC
I've checked:
- inventory
- patron search
- item search (deactivated)
- batch checkouts from patron account
- list of checkouts in patron account
- MARC bibliographic framework structure
- Authorised value categories

Of course there are more... but these all look ok. I am ready to PQA.
Comment 19 Katrin Fischer 2021-02-08 21:00:26 UTC
Also acq baskets are ok!
Comment 20 Katrin Fischer 2021-02-08 21:01:33 UTC
Created attachment 116524 [details] [review]
Bug 27403: Add fixedHeader to Datatables

That's a great plugin to have fixed header.

Test plan:
On the cities table or the patron search table confirm that the header
is floating is you scroll down

Signed-off-by: Owen Leonard <oleonard@myacpl.org>

Signed-off-by: Katrin Fischer <katrin.fischer.83@web.de>
Comment 21 Katrin Fischer 2021-02-08 21:01:37 UTC
Created attachment 116525 [details] [review]
Bug 27403: Disable fixedHeader on itemsearch

It does not work.

Signed-off-by: Katrin Fischer <katrin.fischer.83@web.de>
Comment 22 Katrin Fischer 2021-02-08 21:01:41 UTC
Created attachment 116526 [details] [review]
Bug 27403: (follow-up) Make basket toolbar and table header work together

The fixed header option for DataTables does the same thing that the
hcSticky jQuery plugin does for us on toolbars, so I've gone through the
templates looking for places they might conflict.

On the acquisitions basket page we can add a special class,
"fh-fixedHeader," to the sticky toolbar to tell DataTables that the
table header should float *below* the toolbar.

To test, apply the patch and go to Acquisitions.

- Locate a vendor and a basket for that vendor with multiple orders.
- Adjust the browse window height if necessary to trigger vertical
  scrolling.
- Confirm that as you scroll down the toolbar (with buttons "Add to
  basket," "Edit basket," etc) sticks to the top of the browser window.
- Confirm that as you continue to scroll, the table header sticks below
  the floating toolbar.

Signed-off-by: Lucas Gass <lucas@bywatersolutions.com>

Signed-off-by: Katrin Fischer <katrin.fischer.83@web.de>
Comment 23 Jonathan Druart 2021-02-09 08:50:10 UTC
Pushed to master for 21.05, thanks to everybody involved!
Comment 24 Fridolin Somers 2021-02-12 14:47:14 UTC
Enhancement not pushed to 20.11.x